##  ‍🔔 中文小鸡函数模块介绍
&nbsp;&nbsp;&nbsp;&nbsp;[作者主页](http://kedoutd.cn)  [小鸡函数QQ群](https://jq.qq.com/?_wv=1027&k=yVe9BxJi)  [随堂练模板演示](http://iuc.store)  [作者QQ](https://qm.qq.com/cgi-bin/qm/qr?k=V0f6ccBgR1Wok97mWIYHC4dfAMWTqX4K&noverify=0) 
##### &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;中文小鸡函数 是专门为零基础的 FA2.0 用户提供的一系列模块化组件、中文函数合集。模块化组件，可通过对应功能模块的调用函数实现同一组件或控件的模块代码在不同的地方进行重复利用，相对减少布局代码和活动视图代码的重复出现次数，您只需逐个设置对应的视图参数和事件函数即可。当然，目前的功能模块大多数写法有些臃肿，我会在全部功能接近完善之后、同时学习技术的逐步提升之后，再回头逐个进行优化。
##   👀 向您推荐火眼的作品
  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;在线模拟考试系统:[PHPEMS7.0](http://www.phpems.net/)
##  💁‍♀️ 代码页使用依赖
```
===========================
   通过 require 'import' 来使用导入包，如果页面中包含需要依赖的类，必须在第一行输入这一句才能正常使用相应功能的依赖包。
===========================
```
##  💁‍♀️ 启用模式说明书 📖
```
       小鸡函数已经完成了从自动加载到静态加载的过渡。
===基本调用方法====
--1.关闭此模块开关
--2.请安装静态菜单模块(静态菜单仅一个引导函数和一个菜单JSON文件)
===模式属性值======
--单功能：任何条件下静态化单独调用某个函数或函数分类
--全静态：一键静态化调用全部函数，可绕过main页面在任何环境下单独贴入指定的函数。
===模式差异描述=====
全自动加载:
在模块开启之后，自动在main页面下循环执行
优点：无需手动调用，方便省事
缺点：循环执行，高负荷，不能跨过main单独在子页面调试
==================
全静态加载：
优点：不启用不运行，基本没负荷，能绕过main页面单独在任何页面调度
缺点：像您写代码时一样，由于只加载一次，一定要合理安排函数顺序，否则可能会产生异常，
错误排序举例：您写一个弹出消息的中文函数，但是将其放在了调用函数后面，那么可能会报错。
==================
单功能加载：
优点：想在何时何地单独调用一个函数，都可随意调用，如果都是在局部环境中，那么您需要对应调用两次，反之，仅需一次
缺点：功能之间的调用排序、关联性质要搞清楚。
例如：您调用了复制链接函数，但是您又没有调用浏览器监听或者监听函数在调用函数后面，那么复制的链接是空值。再例如：指示器点击事件监听，您没有开启指示器，就会报错。
==================
===您可能存在疑问===
为什么停用小鸡一定要启用另一个模块？换汤不换药吗？
当然不是！您这样理解，当您启用：
启动中文函数小鸡("静态版")
如果不使用引导模块那么这个启动函数从哪里来呢？又是依靠什么执行我们贴入的第一个函数？
因此，我们需要一个它能调用的目标函数，而这个函数就存在于静态版中，也就是说，静态版就是个快捷方式，您需要手动启用，它才会在小鸡模块路径中去找您需要的函数拿过来用。这样的好处是，不再在main页面下循环执行一大堆的事情。此时它是完全静止的。静态调用与自动加载不同，自动加载仅能在main页面下跑起来，而静态加载可以在page下建立更多更深的路径，然后在任何有调用需求的页面中单独使用模块。
===========================
```
##  💁‍♀️ 指示器检测与设置
```
===========================
1.使用浏览器函数必须设置指示器
2.如果没有设置指示器，将会给予您提示
3.如果没有设置指示器，将会收到循环的创建提醒
4.此时请您选择“关闭指示器检测”菜单来解决
===========================

--=========================
--如果您不需要设置网页
--a.请使用以下空链接设置至少一个指示器
--指示器名称：请任意填写
--b.指示器链接请填写以下其一：
--=========================
--about:blank
--about:empty
--=========================
--如果您需要访问一个空网页但又要网页加载完毕
--我的方法是这样的，仅供参考
--=========================
--https://www.0.com/
--https://www.1.com/
--=========================
--说明：
--about:blank，加载一个可能包含网页元素的空页面
--about:empty，加载一个不包含任何网页元素的空页面
--https://www.0.com/，可能包含404信息的空白但不为空的页面
--https://www.1.com/，可能包含404信息的空白但不为空的页面
--=========================
--您可以使用以下函数来结束
--=========================
关闭指示器检测()
--=========================
```
##  💁‍♀️ 更换应用主题功能使用说明
```
===========================
基本使用方法：
1.在您的应用中新建主题，FA2主题名称都是英文命名
2.您必须保证至少有两个可用的主题
3.把您命名好的名称填到需要设置的对象参数中
4.主题文件在您工程的theme目录，后缀是json
5.当您设置参数的时候无需携带后缀

注意事项：
       如果您不小心设置了一个不存在的主题，这会导致主题列表清空，工程破损，但并不是真的坏掉了。您可以再次设置正确的主题，就能恢复正常，如果遇到正常名称重新设置也无法修复，很简单，您可以新建一个空的工程，替换根目录的json文件，再进入main目录替换该目录下的json文件，替换完这两个之后，在根目录下可以顺便把应用包名改回来，不会改的话，导入工程之后再改也行。

主题设置功能介绍：

1.支持设置当前主题时顺便把默认主题设置也搞到一起，这样你不用自己写一堆其它东西，一句判断，一个函数调用即可；

2.支持切换成功时提示消息的自定义；

3.支持在main页面下直接使用，也就是说您可以通过添加随机条件来实现每次启动随机主题；

4.您还可以通过设置指定更变顺序的条件启动时自动按序出现；

5.您可以无上限地设置主题，然后抽几款作为每次启动自动轮换，其它的留给用户按喜好自己操作，您可以通过闭合开关来控制这些。
===========================
```
##  💁‍♀️ 使用界面管理器
```
===========================
界面管理器函数的使用
===========================
获取状态和使用说明：
这是按照我自己的理解来说可能存在描述不当
如发现问题请告知我修订此描述，先谢！
大概应该就是这么个意思，明白就行
说实话，用文字语言描述代码逻辑有点撇脚
===========================
使用方法描述：
===========================
先获取：界面管理器()
再使用：界面管理器().某函数或操作
===========================
===========================
类似角色描述：
===========================
界面管理器()是视图界面中处于最父级的视图管理者
我们可以把 界面管理器() 这个函数角色理解成：视图总容器或类似于一项根级服务
其服务对象包括所有处于该视图界面中的组件、控件等
在这个视图下面有多级，这取决于您需要用到哪些组件和控件
当您需要获取某个处于其第二层或第三层或更多层的组件或控件时
它始终是一个引路者，没有它，将会找不到目标对象
假设有这么一个对象：
菜单项目()
它处于 滑动菜单() 这个组件内
而 滑动菜单() 又处于 滑动视图() 内
滑动视图 又处于 界面管理器()
获取目标：菜单项目()
那么应该是这样的：
界面管理器().滑动视图组件().滑动菜单().菜单项目()
===========================
再举个实例：
就拿搜索栏来说吧。
1.界面管理器()
2.从界面管理器获取搜索栏
界面管理器().searchEditText
3.赋值搜索栏名称
搜索输入框=界面管理器().searchEditText
4.使用的时候我们就可以直接使用变量值来做一些事情：
例如变量值：搜索输入框
===========================
实际使用时不需要第二步，这是便于理解，通常是同时获取和赋值
===========================
界面管理器()
搜索输入框=界面管理器().searchEditText
===========================
```
##  💁‍♀️ 页面状态事件控制
```
===========================
1.页面状态事件和FA1基本相同
2.如果使用这些函数，请将所有运行代码分类其中
3.您可以理解成是五个分页或五个全局代码分类
===========================
```
##  💁‍♀️ 对话框扩宽函数
```
===========================
对话框扩宽(控件ID,"2")
第二个参数：扩宽等级支持1-5级，需加上引号
设置函数放到对话框设置事件的布局设置下面
例如：
TSTC= AlertDialog.Builder(activity)
    千变窗口ID=TSTC.show()
    千变窗口ID.getWindow().setContentView(loadlayout(TSNR));
对话框扩宽(TSTC,"3")
===========================
```
##  💁‍♀️ 使用字体变量设置字体
```
===========================
1.请在布局中文本控件使用；
示例：
{
TextView,
layout_width="fill",
Typeface=等宽斜体,
},
2.外部设置方法：
文本控件ID.Typeface=有衬粗体
===========================
```
##  💁‍♀️ webView字段
```
==========================
思前想后，还是把这个变量加回来，因为我们都用习惯了，和FA1一样，可以使用此字段来设置浏览器布局。
webView.addView(loadlayout(layout))
==========================
```
##  💁‍♀️ 小鸡全屏模式
```
==========================
1.函数：小鸡全屏模式(屏幕方向);
2.屏幕方向：nil、0、1、8、9、10;
3.参数数值：nil为正向竖屏，1为竖屏，0为右转横屏、8为左转横屏、9为倒置竖屏、任意其它数值为自动转屏。参数数值无需引号，如果您填写的参数非数值则视为nil，即正向竖屏。
==========================
```
##  💁‍♀️ 启用系统当前路径
```
==========================
这个功能可以实现您自定义文件储存路径，是相对路径，固定获取您将要调用图片的目录位置，比如：您正在编辑的lua文件路径是main目录，那么，它将获取到main目录，您可以通过赋值或者直接使用函数来获取您的图片路径，举例：
--通过赋值来获取路径：
local 当前系统路径=当前系统路径()
然后接上图片位置，如果main目录下创建了图片子目录，如：tupian，那么应该是这样写：
当前系统路径..'/tupian/tupian.png'
如果tupian.png直接存在于main目录下，则是：
当前系统路径..'/tupian.png'
--调用函数获取路径：
当前系统路径()..'/tupian/tupian.png'
当前系统路径()..'/tupian.png'
==========================
```
##  💁‍♀️ 首次启动欢迎页面
```
==========================
首次启动欢迎页面仅作为您需要加载的新活动页面，开始我想直接写死，让您直接填写参数，后来觉得这样会丧失灵活性，在某些特殊情况下可能不好用，所以最终做了这个单页，让您能自行决定何时弹出，如果您不能实现控制弹出的条件，那么示例中也附带了首次启动标签演示代码，您可以直接粘贴此代码到main/main.lua文件中，若您知道怎么写，那就当我没说吧。
==========================
```
##  💁‍♀️ 应用启动欢迎辞
```
===========================
完整调用函数
===========================
应用启动欢迎辞(图片路径,提示内容,提示圆角,提示位置,提示背景)
===========================
调用示例
===========================
应用启动欢迎辞('qidong.jpg','嗨！欢迎回家！','5dp','下','#ffffffff','#ff808080')
===========================
参数说明
===========================
图片路径:必填参数，请将图片放到工程pages/images目录下
参数说明:填写包含jpg或png后缀的图片文件名，如:'abc.jpg'
===========================
提示内容:可选参数，不填写则仅显示图片
参数说明:提示内容必须是中文、英文、常规标点符号，不支持代码内容和转义符，如 '亲爱的，欢迎回家！'
===========================
提示圆角:可选参数，不填写则无圆角
参数说明:可直接输入圆角值，空值 ' ' 表示无圆角
如 '5dp'，也可输入:'小'，'中小'，'中'，'中大'，'大'
===========================
提示位置:可选参数，不填写则默认底部显示
参数说明:支持输入 '上'，'中上'，'中'，'中下'，'下'
===========================
提示背景:可选参数，当值为nil时启用默认背景，
当该值为 ' ' 空值时透明背景，并强制文字为黑色
参数说明:请输入#字开头6-8位颜色值，如 '#5500dddd'
===========================
===========================
提示字色:可选参数，当值为nil时强制黑色文字，
当该值为 ' ' 空值时半透明黑色背景，并强制文字为白色
参数说明:请输入#字开头6-8位颜色值，如 '#5500dddd'
===========================
特别说明:
===========================
当背景色和文字色值都为nil，透明背景，白字
当背景色为 ' ' 值，文字色强制为黑色，设置无效。  
===========================
```
##  💁‍♀️ 弹出新消息(终极增强版)
```
==========================
1.已经支持消息内容换行了；
弹出新消息('你好，祖国！\n你好，祖国')
2.增加了字体大小参数：
弹出新消息('你好，祖国！','89%h','29dp','#ff153548','#ffffffff','15sp')
3.重新定义了高度概念，之前的表达方式是相反的，
比如：5%h应该是从顶部的5%h距离位置弹出，原函数中却从底部距离5%h高度值弹出，虽然影响不大，但还是修正了一下，因此，您之前写的高度值的弹出位置会发生相反高度的变化；
4.除此之外，高度值还支持了档位设置，1-35档，1档为底部弹出，35档为顶部弹出，当您输入的高度值不包含'%h'单位的时候，默认使用档位，当您输入的数字是1~35之外的其它值，那么默认使用3档；
5.新版本支持了简写，示例1：

弹出新消息('你好，祖国！','5','15','ff153548','ffffffff','15')

以上是启用了高度档位5，省略了圆角的dp单位，省略了颜色值的#号，省略了字体大小的sp单位

我们再来看示例2：

弹出新消息('你好，祖国！','85%h','15','ff153548','ffffffff','15')

以上是简写方法，启用了弹出高度值，高度值因为有纯数字档位设置方式，因此不能简写；

完全写法：

弹出新消息('你好，祖国！\n无论我走到哪里\n都留下一首赞歌','88%h','15dp','#ff153548','#ffffffff','15sp')

如何跳过中间参数，设置两边的参数?

1.为了防止后面的值前移导致参数错位而发生报错，需键入空引号来赋空值；
2.如果完全留空，又填写了后面的值，同样为解决上述问题，留空参数后面的参数将会被销毁，因此不会生效

写法示例：

弹出新消息('你好，祖国！\n无论我走到哪里\n都留下一首赞歌','','','','','15')
==========================
```
##  💁‍♀️ 浏览器事件监听
```
===========================
1.通过启用浏览器监听浏览器行为来控制指定事件的触发
2.开启浏览器监听默认自动更新顶栏标题，如需关掉自动更新toolBar标题，可以使用标题开关函数控制函数如下：
  自动顶栏标题('关')
===========================
```
##  💁‍♀️ 浏览器视图控制
```
===========================
  此函数主要是对webView控件的视觉控制，通过它我们可以实现小窗显示web页面内容、缩放效果、调试模式效果等。
开关值：'开'、'关'
===========================
```
##  💁‍♀️ 功能函数和变量
```
===========================
函数部分：
===========================
隐藏标题栏()
说明：将顶部标题栏隐藏
===========================
隐藏状态栏()
说明：将状态信息栏隐藏
===========================
分离状态栏()
说明：状态栏与布局脱离
===========================
设置状态栏颜色(颜色值)
说明：设置状态栏的前景色，仅支持部分机型，一般通常只有黑色和白色，当设备不支持该函数时，可以通过 FA2.0 自带的深色模式和强调色来控制状态栏文字显示黑色或白色
===========================
设置状态栏背景(背景颜色)
说明：设置状态栏的前景色
===========================
虚拟按钮透明化()
说明：一般手机设备通常默认开启虚拟按钮的，如果初始效果非透明，可以尝试此函数，并不保证所有设备生效。
===========================
--关闭搜索栏()
说明：当搜索栏状态为展开时，可以使用它来关闭，仅支持默认搜索栏。
===========================
--搜索栏展开状态()
说明：可用此函数检测搜索栏处于关闭还是展开状态，一般会配合 开启/关闭搜索栏() 函数的使用。
--=========================
--复制文本(文本内容)
说明：复制指定的文本或变量值，例如复制浏览器链接或标题。

复制链接：
复制文本(浏览链接())
复制文本(WebU())

复制标题：
复制文本(浏览标题())
复制文本(WebT())

注意：如果是在 非主动触发状态(即，不通过点击或长按某事件的触发行为)来复制标题内容，请使用：

task(1,function()
复制文本(浏览标题())
end)

或

task(1,function()
复制文本(WebT())
end)
==========================

==========================
禁用文本选择菜单(开关)
说明：当您需要禁止用户复制剪切页面内容的行为时，此函数可以实现，但部分系统强制使用系统自带的选择菜单时，此函数可能不生效。

开关参数：'开'，'关'
==========================
系统顶栏返回按钮(开关)
说明：如果需要启动顶栏的默认返回按钮，仅部分设备生效。

开关参数：'开'，'关'
==========================
  以下函数的参数除变量名之外均需要引号包裹起来，路径变量名允许直接使用文件路径，若直接使用路径，同样需要引号包裹。
==========================
--获取文件最后修改时间(路径变量名,文件路径)
--关闭弹窗对话框(视图变量名)
--读取文件内容(路径地址,路径变量名,内容变量名)
--写入文件内容(路径地址,路径变量名,写入内容)
--========================

--========================
安装应用程序(安装包路径)
说明：安装包路径请以/sdcard/开头，需引号，无需后缀，例如a目录下的abc.apk，正确写法是：
安装应用程序('/sdcard/a/abc')
==========================
==返回手机桌面()
说明：不结束应用进程
==========================
==清空应用数据()
说明：结束应用进程
==========================
==退出应用()
说明：结束应用进程
==========================
==重启应用()
说明：结束后再恢复应用进程
==========================

--========================
--变量部分：
--========================
--本应用包名
--顶栏菜单
--侧滑菜单
--标题点击
--抽屉头像
--抽屉背景
--抽屉主标
--抽屉副标
==========================
  说明：以上变量值可以实现一些与之对应的功能，例如：本应用包名，其值就是我们创建应用时的内部安装包名称，可以通过获取此值来实现应用重启、退出、安装更新包的相关操作，而 顶栏菜单 变量则可以实现顶栏菜单的相关设置、点击、长按事件的触发，在这里我们还可以将其理解为自定义顶栏菜单的中文ID。
==========================
```
##  💁‍♀️ 子页面网址接收
```
==========================
1.空值加载指的是当进入收子页面链接为空时需要加载的页面;
2.如不需要请填写:about:empty;
3.如需判断来源链接，可配合 链接标识生成器 使用。
==========================
```
##  💁‍♀️ 链接标识生成器
####  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;🎈 使用方法：
```
==========================
1.请放在接收到子页面链接之后的位置；
2.先在来源页创建子页面访问本页：进入子页面("本页面名称","网址链接")
3.使用以下变量函数生成链接标识
4.复制文本(链接标识)
5.通过标识作为判断条件执行需要执行的事件
==========================
```
  
####  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;🎈 第一步：接收子页面传来的链接  
```
==========================
local 接收链接=...
local 页面标识=p
local 空值加载='about:blank'
local 网址接收=子页面网址接收(接收链接,页面标识,空值加载)
==========================
```
####  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;🎈 第二步：启用链接生成器
```
==========================
local 链接标识生成=链接标识生成器()
==========================
```
####  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;🎈 第三步：获取链接标识值
```
==========================
复制文本(链接标识)--自动生成，通过复制得到，将结果填到下面作为判断条件
==========================
```
####  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;🎈 第四步：填写链接标识值到判断条件
```
==========================
if 链接标识=="ABOUTBLANK" or 链接标识=="ABOUTEMPTY" then
  弹出新消息("来源页为空或没有来源网页")
 elseif 链接标识=="RIMLPNZOPE" then
  弹出新消息("来源于main进入子页面函数的访问")
 elseif 链接标识=="AJDBDHDJGVB" then
  弹出新消息("来源于另一个标识页面")
end
==========================
```
##  💁‍♀️ 获取日期和时间
```
==========================
--获取年份(分割符,格式)
--分隔符：'-'，'_'，'：'，':'，'|'，'~'，空格，任意值
--格式：'2'，'4'，留空，仍意值

--获取日期(分割符)
--分隔符：'-'，'_'，'：'，':'，'|'，'~'，空格，任意值

--获取时间(分隔符)
--分隔符：'-'，'_'，'：'，':'，'|'，'~'，空格，任意值

--获取时间秒数(分割符)
--分隔符：'-'，'_'，'：'，':'，'|'，'~'，空格，任意值
==========================
```
##  💁‍♀️ 储存权限申请弹窗
```
==========================
您至少需要一个条件前提再调用，例如：
1.使用权限申请弹窗的回调状态
2.判断悬浮框架是否正常
3.判断需要创建的文件夹路径是否为nil
4.判断是否为首次启动
5.判断是否可以读入文件
6.判断是否可以打开相册
7.判断是否已经可以删改查本地数据
8.判断授权窗口是否弹出或已经授权过

满足以上任一条件来控制本窗口是否弹出即可
==========================
```
##  💁‍♀️ 远程加载代码
```
==========================
远程代码调用函数：
远程代码(网址,起标,终标,本地混用函数名)
注：标签符号可以随意任何字符，例如：
【＃￥‖￡＆『〗】都是可以的

'本地混用函数名'无需引号，其它参数需引号

--本地函数调用示例:
远程代码('这里填网址','【远程代码开始】','【远程代码结束】',插入本地混用代码)

远程加载代码内容：
     【远程代码开始】
       --这里是代码内容
     【远程代码结束】

这里提供了一个本地混用函数接口：
插入本地混用代码()

此函数可以实现紧跟着远程代码后面运行
虽然是写在本地的，此函数内的代码
同样会被视为网址来源中的代码的一部分
可以实现远程本地结合杂用
也可在其内实现无限远程网址套娃
只需在此函数内再调用一次第一部分
继续套娃的话，在第二次调用内再插入：
本地混用代码()
==========================
```
##  💁‍♀️ 万能新拟物对话框使用方法：
```
==========================
1.必填参数的调用方法：

万能拟态对话框(标题_文字,消息_文字,积极_文字,消极_文字)

说明：仅弹窗展示内容的情况下，我们可以省略后面的全部参数

2.自定义ID的调用方法：

万能拟态对话框(
标题_文字,消息_文字,
积极_文字,消极_文字,
窗口_地址,标题_地址,消息_地址,输入_地址,
积极_地址,消极_地址,中立_地址
)

说明：同样，启用事件ID的情况下，我们可以省略后面的全部参数

3.可选参数的调用方法：

万能拟态对话框(
标题_文字,消息_文字,
积极_文字,消极_文字,
窗口_地址,标题_地址,消息_地址,输入_地址,
积极_地址,消极_地址,中立_地址,
标题_颜色,"",按钮_颜色,
标题_背景,消息_背景,"",
窗口_圆角,"",拟态_风格,
窗口_阴影,按钮_阴影,
标题_字号,"","",
标题_字体,"","",
"",控件_分割,"",
"","",
说明：当我们需要设置部分且不相邻的参数，不设置的参数我们可以使用""或者nil来置空，当参数值为空则会显示默认参数。
)

4.完全参数的调用方法：

万能拟态对话框(
标题_文字,消息_文字,
积极_文字,消极_文字,
标题_颜色,消息_颜色,按钮_颜色,
标题_背景,消息_背景,按钮_背景,
窗口_圆角,按钮_圆角,拟态_风格,
窗口_阴影,按钮_阴影,
标题_字号,消息_字号,按钮_字号,
标题_字体,消息_字体,按钮_字体,
中立_文字,控件_分割,底边_背景,
启用_输入,提示_文字,
窗口_地址,标题_地址,消息_地址,输入_地址,
积极_地址,消极_地址,中立_地址,
最小_输入,最大输入
)

--说明：完全参数所有参数值如下：
标题_文字="标题"
消息_文字="消息"
积极_文字
消极_文字

标题_颜色="#ff444444"
消息_颜色="#ff606060"
按钮_颜色="#ff808080"
标题_背景="#ffffffff"
消息_背景="#ffffffff"
按钮_背景="#ffffffff"
窗口_圆角="12dp"
按钮_圆角="8dp"
拟态_风格="1"--0、1、2、3四个值
窗口_阴影="5dp"
按钮_阴影="5dp"
标题_字号="16sp"--单位sp
消息_字号="13sp"
按钮_字号="15sp"
标题_字体="加粗"--只有加粗、默认两个值
消息_字体="默认"
按钮_字体="默认"
中立_文字="中立按钮"
控件_分割="1"--10个值，从1-10
底边_背景="按钮的整排背景颜色"
启用_输入="启用"--两个值，启用、关闭，启用后对话框变成输入框
提示_文字="hint文字内容"
窗口_地址="窗口id"
标题_地址="标题id"
消息_地址="消息id"
输入_地址="输入框id"
积极_地址="积极按钮id"
消极_地址="消极按钮id"
中立_地址="中立按钮id"--留空不显示
local 最小_输入="1" --禁止输入请设置为0
local 最大_输入="5000"--设置无限请使用仍意空值变量名

4.点击事件说明：
    这需要您根据您自己设置的id而定，这个没有写死，方法和平常一样
    
5.文本输入框的文本获取：
    请勿使用调用参数中的变量值，而是应该和您之前获取一样的方法，例如：您给消息ID设置了id，地址为"消息id"，那么：
    输入文本获取示例如下：
    local 消息文本=消息id.text
    改变文本内容：
    消息id.setText("覆盖内容")
    改变文字颜色：
    消息id.setTextColor(0xff11999999)
    
关闭窗口：关闭新拟物对话框()

    无论您使用此函数设置多少个弹窗弹出，那么关闭窗口的函数只有一个，统一的，不用频繁修改前面的字段，关闭顺序依次从顶层执行，弹出了多个窗口的情况下，支持叠加关闭窗口的操作。

==========================
```
##  💁‍♀️ 千变对话框-2021
```
===========================
大半年没更新小鸡函数了，我以为被遗忘了，虽然写得烂，但是还得写，这次的更新主要就是针对千变对话框对其它弹窗造成的冲突困扰，为了尽量避免与其他作者的弹窗模块产生冲突，变量名已经修改了，所以，之前您如果应用了这个弹窗，那么您需要做一下微调，在各个变量名前面加上“千变”。此外，这一版修复了文本对齐失效的问题，修改了条件判断规则，减少1-999编号之间的款式生成时的重复率。增加了消极按钮文字的定义，修复几个点击开关冲突。目前貌似没有发现其它比较明显的大问题。
完整版调用示例：
--===========================
--点击事件函数
--===========================
--首先创建点击事件函数
function 积极点击()
  弹出新消息([[积极点击
请将 千变按钮事件 参数赋值：
〖点按〗或〖点击〗]])
end
function 积极长按()
  弹出新消息([[积极长按
请将 千变按钮事件 参数赋值：
〖点按〗或〖长按〗]])
end
function 中立点击()
  弹出新消息([[中立点击
请将 千变文本事件 参数赋值：
〖点按〗或〖点击〗]])
end
function 中立长按()
  弹出新消息([[中立长按
请将 千变文本事件 参数赋值：
〖点按〗或〖长按〗]])
end
function 文本点击()
  弹出新消息([[文本点击
请将 千变文本事件 参数赋值：
〖点按〗或〖点击〗]])
end
function 文本长按()
  弹出新消息([[文本长按
请将 千变文本事件 参数赋值：
〖点按〗或〖长按〗]])
end
--对话框参数
--===========================
local 千变风格编号='251'
local 千变标题文字='千变对话框使用帮助'
local 千变积极按钮='积了个极'
local 千变消极按钮='消了个极'
local 千变按钮事件='点按'
local 千变按钮位置=nil
local 千变中立按钮=nil
local 千变文本事件='点按'
local 千变禁返开关=nil
local 千变标题风格=nil
local 千变文本风格="左"
local 设置字体="默认规体"
local 窗口扩宽=nil
local 千变窗口ID=使用帮助
local 千变积极点击=积极点击
local 千变积极长按=积极长按
local 千变中立点击=中立点击
local 千变中立长按=中立长按
local 千变文本点击=文本点击
local 千变文本长按=文本长按
local 千变对话内容=[[
青丝染、上风霜、该用什么、来解救眼角洋溢的幸福，是对昨日的爱恋，路口的大榕树，笔直的站着，它依旧在翘首，依旧在思念，依旧在等待，你的归来。荏苒时光是否会将我的思念击碎，然后化成漫天飞舞的尘埃，涌进你的世界，将你的思绪填满，最后我的思念变成你的回忆？
半支红烛，摇曳的是婀娜多姿的情怀，软塌寒凉，温暖的你早已离去多时，独坐寒窗，企盼的是你的出现，可是怎奈情深缘浅，你已不在我的视线之内。茫茫红尘，多少痴男怨女在灯下惆怅，多少至死不渝被时光打破，多少满腔深情被辜负。月老似乎忘了世间安得双全法，如来与卿，怎可兼得？我只盼青灯古佛，寂寥空旷的佛堂能够将我的思念全部接纳，然后化作袅袅佛音，庇佑世间男女。
]]
--[[新版本千变对话框
       修改变量名，之前套用了千变对话框的变量名成前面需要加上“千变”，因为是全局变量，和其它弹窗之间存在冲突，上一个版本里面的文本对齐失效了，增加消极按钮文字修改，判断句方法修改了，以及其它一些已知问题都修复了，如果还有问题，请反馈给我处理一下。

参数值说明：
       
[千变风格编号]

示例：'1'，'15'，'9850' 
说明：有效值总共10000个，从0-9999，刚好一万个风格，超出该值将可能出现重复的，也可能会组合出新的来；

[千变标题文字] 
示例：'标了个题'，'我是标题'，'标题文本' 
说明：没有说明

[千变对话内容]
示例：'我是对话框内容'，'突然想射点什么'，'哈喽！摩西摩西！' 
说明：没有说明

[千变积极按钮]
示例：'确定'，'立即前往'，'马上去抢' 
说明：没有说明
local 千变对话内容=[[
新版本已升级为千变对话框
       原'百变对话框'函数名请修改，新版本缩短了一半的判断条件，增加了自由组合条件，最多可组合出9999种不完全重复风格；第二版修复了有些组合无法生成的问题，在偏移值加入了适合该边距的字体大小。

参数值说明：
       
[千变风格编号]

示例：'1'，'15'，'9850' 
说明：有效值总共10000个，从0-9999，刚好一万个风格，超出该值将可能出现重复的，也可能会组合出新的来；

[千变标题文字] 
示例：'标了个题'，'我是标题'，'标题文本' 
说明：没有说明

[千变对话内容]
示例：'我是对话框内容'，'突然想射点什么'，'哈喽！摩西摩西！' 
说明：没有说明

[千变积极按钮]
示例：'确定'，'立即前往'，'马上去抢' 
说明：没有说明

--以下是可选参数，可以不填

[千变按钮事件]
示例：'点击'，'点按'，'长按'，nil
说明：点击，只点击不长按，不启用长按事件；点按，启用点击和长按事件；长按，启用长按事件，不启用点击事件；nil，默认只启用点击事件。

[千变按钮位置]

示例：'居左'，'居右'，'居中' ，nil--默认居左
说明：按钮的对齐位置，也可以直接写成'左'，'中'，'右'；

[千变中立按钮]
示例：'高级功能'，'帮助'，'会员专享'，'更多'，'检查更新'
nil--禁止启用千变中立按钮，默认禁用
说明：没有说明

[千变文本事件]
示例：'点击'，'点按'，'长按'，nil
说明：没有说明

[千变禁返开关]
示例：'开'，'关'
''，默认关闭开关
nil--默认跟随风格改变
说明：开启之后，禁止用户滑动退出窗口；

[千变标题风格]
示例：'1'，'2'，'3'，或 '左'，'中'，'右'，
nil--使用默认搭配方案
说明：如果是以下值，则为偏移量调整：'4'，'5'，'6'，'7'，'8'，

[千变文本风格]
示例：
'1'，'2'，'3'，'4'，'5'，'6'，'7'，'8'
nil，使用默认值
说明：文本的偏移值，字体大小，字体款式，显示位置

[设置字体]
示例：
'默认规体'，'默认粗体'，
'有衬规体'，'有衬粗体'，
'等宽规体'，'等宽粗体'，
'无衬规体'，'无衬粗体'，
'有衬斜体'，'等宽斜体'，
nil，使用千变自带风格的字体样式
说明：参数请带上引号

[窗口扩宽]
示例：
'1'，'2'，'3'，'4'，'5'
nil，默认'fill'宽度
说明：开启之后，窗口宽度会达到90%宽度，反之，fill宽度

[千变窗口ID]
local 千变窗口ID=帮助弹窗
local 千变窗口ID=领券对话框
local 千变窗口ID=提示弹窗
说明：如果您需要用到窗口ID，做一些操作，例如：外部控制关闭事件，不赋值的话，您也可以使用默认的 [千变窗口ID]，但是如果您在同一个页面调用多次，建议逐个赋值。
[千变积极点击]
[千变积极长按]
[千变中立点击]
[千变中立长按]
[千变文本点击]
[千变文本长按]
示例：
function 千变积极按钮点击()
  --这里是点击事件代码
end
local 千变积极点击=千变积极按钮点击
说明：如果您需要修改事件函数名称，可如上述修改。]]
--===========================
--调用函数
--===========================
千变对话框(
 --必填参数
千变风格编号,千变标题文字,千变对话内容,
千变积极按钮,千变消极按钮,千变按钮事件,
--可选参数
千变按钮位置,千变中立按钮,千变文本事件,
千变禁返开关,千变标题风格,千变文本风格,
--可选扩展参数
设置字体,窗口扩宽,千变窗口ID,
千变积极点击,千变积极长按,千变中立点击,
千变中立长按,千变文本点击,千变文本长按)
==========================
```
##  💁‍♀️ TextView文本对齐()
```
===========================
我知道很多人像我一样苦恼于安卓文本控件没有justifyText属性，这使得我们的对话框内容一直都是不对齐状态，我这里采用了文字间距填充方案，但英文显示效果非常不理想，不过，只要您的弹窗内容全部采用全角，那就逼尤特佛尔了。对全角的支持相对比较满意，但半角就太差劲了。
函数调用方法如下：
TextView文本对齐(控件ID,启用类型,字母填充)
注意事项：ID不需要引号，字符类型和字母填充参数都需要引号
全角匹配示例：
TextView文本对齐(Treadme,"全角")
当您使用全角模式，请丢弃字母填充参数，当您启用半角模式，您可以设置字母填充类型，'大写'、'小写'、和'全部'这三个值。
--==========================
```
##  💁‍♀️ 语音菜单实现代码
```
==========================
--使用方法请参阅模块说明
--SoundPool只用能于小型背景音
--1.请创建soundplayer.lua,然后保存此代码；
--2.请在main目录创建sound目录，并放置音频文件；
--3.设置音频资源名称，和音频装载；
--4.请在main页面添加代码：
--  import'soundplayer'
--  WAV播放器(这里是音频资源名称,这里是音频资源路径)
==========================
```
##  💁‍♀️ 息屏时钟屏保代码
```
==========================
--使用Task归递修改文本实现
--您可以在此基础上画一个更漂亮的时钟
--唤醒方法:
--1.请锁屏
--2.解锁时触发屏保
==========================

```
##  💁‍♀️ 弹出LUA对话框
```
==========================
1.支持自定义事件函数名称
2.事件函数：积极函数名,消极函数名,中立函数名
说明:依次放在最后面生效
3.如果不需要中立按钮，后面两个参数不要填
4.文本较多建议使用中括号替代引号便于换行
5.如果不需要中立按钮事件，注释或删除即可
==========================

==========================
--写法一：变量赋值
==========================
local 对话标题='温馨提示'
local 对话消息='鸡鸭鱼肉蛋🥚'
local 积极按钮='积极按钮'
local 消极按钮='消极按钮'
local 中立按钮='中立按钮'
--点击事件
function 积极事件()
  弹出新消息('鸡了个鸡')
end
function 中立事件()
  弹出新消息('鸭了个鸭')
end
function 消极事件()
  弹出新消息('鹅了个鹅')
end
LUA对话框(对话标题,对话消息,积极按钮,消极按钮,积极事件,消极事件,中立按钮,中立事件)
==========================

==========================
--写法二示例：
==========================
--单行书写
==========================
--点击事件
function 积极事件()
  弹出新消息('鸡了个鸡')
end
function 中立事件()
  弹出新消息('鸭了个鸭')
end
function 消极事件()
  弹出新消息('鹅了个鹅')
end
LUA对话框('对话标题','对话消息','确定','取消',积极事件,消极事件,'更多',中立事件)
==========================

==========================
--多行书写：
==========================
--点击事件
function 积极事件()
  弹出新消息('鸡了个鸡')
end
function 中立事件()
  弹出新消息('鸭了个鸭')
end
function 消极事件()
  弹出新消息('鹅了个鹅')
end
LUA对话框(
'对话标题',
'对话消息',
'确定','取消',
积极事件,
消极事件,
'更多',中立事件
)
==========================
```
##  💁‍♀️ 文本输入框
```
==========================
--精简参数模式
==========================
文本输入框(模式,输入框ID,标题内容,提示信息,预置文本,积极按钮)
--========================

--========================
--完全参数模式
--========================
文本输入框(款式,输入框ID,标题内容,提示信息,预置文本,积极按钮,输入积极函数名,消极按钮,输入消极函数名,中立按钮,输入中立函数名)
==========================

==========================
--弹窗款式参数
==========================
--款式请填:0-9纯数字，带引号，如:'1'，留空加载第0款
==========================

==========================
--创建事件函数
==========================
function 确定按钮事件()
  弹出新消息('确定')
end
function 中立按钮事件()
end
function 消极按钮事件()
end
==========================
--调用函数
==========================
文本输入框('9','input','输入标题','提示:xxx','请输入内容','确定',确定按钮事件,'取消',消极按钮事件,'更多',中立按钮事件)
==========================
```
##  💁‍♀️ 卡片菜单对话框(新版支持百分比卡宽值)
```
==========================
1.卡片菜单调用示例，可以换行
2.菜单项目最少2项，最多支持15项
3.支持标题颜色和圆角设置
4.不需要的参数请使用 \"\" 占住空位
--=========================
--创建点击事件函数

function 菜单1点击()
  弹出新消息('点击了菜单1')
end
function 菜单2点击()
  弹出新消息('点击了菜单2')
end
function 菜单3点击()
  弹出新消息('点击了菜单3')
end
function 菜单4点击()
  弹出新消息('点击了菜单4')
end
function 菜单5点击()
  弹出新消息('点击了菜单5')
end

--=========================
--视图窗口调用函数
--=========================
卡片菜单('菜单选项','#ffeeeeee','#ff808080','5dp','中','居中','较窄','中','菜单1','菜单2','菜单3','菜单4','菜单5')
--=========================

--=========================
--参数说明
--=========================
[支持参数]
  标题(菜单标题)：'窗口标题'
  标位(标题位置)：'左'|'中'|'右'
  卡位(卡片位置)：'居中'|'微上中'|'略下左'|'较上中'|'靠下右'|'更上中'|'最下左'
  卡宽(卡片宽度)：'最窄'|'较窄'|'偏窄'|'略窄'|'适中'|'略宽'|'偏宽'|'较宽'|'最宽'
  此外，卡宽已经支持了直接输入百分比值，例如'50%w'，%w符号可省略，直接写成'50'
  重力：'左'|'中'|'右'
  卡片位置合并参数的使用：
     第一个参数：微，略，较，靠，更，最表示侧重居上居下的程度
     第二个参数：表示字上或下，
     第三个参数：左，中，右
  其实这是把上下左右位置几个参数合并成一个参数的，

[点击事件]
-- 以下为示例点击事件，请放在调用函数上面
function 菜单1点击()
   print('点击了菜单1')
end
function 菜单2点击()
   print('点击了菜单2')
end
[示例写法]
-- 调用函数：卡片菜单(标题,标色,字色,圆角,标位,卡位,卡宽,重力,菜单1,菜单2,菜单3)
-- 示例写法：卡片菜单('菜单选项','#ffeeeeee','#ff808080','5dp','中','居中','较窄','中','菜单1','菜单2')
[补充说明]
  1.这是一个点击弹出选项菜单，不适合做数据列表
  2.最少支持2个项目，最多支持15个项目，可以滑动
  3.只有左右参数的项表示该项上下是自适应的
==========================
```
##  💁‍♀️ T36魔改动画
```
==========================
组合动画教程：
==========================
  如果您需要使用此函数创建组合动画，理论上可以创建无数种组合类型。
  请使用task，示例如下：
==========================
task(500,function()
  T36魔改动画(控件ID,左旋转)
end)
task(500,function()
  T36魔改动画(控件ID,右顶甩)
end)
task(500,function()
  T36魔改动画(控件ID,隐正显)
end)
==========================
效果参数如下：
==========================
  旋转类：左旋转，右旋转，左渐旋，右渐慢，左慢旋，右慢旋，左快旋，右快旋，左飞旋，右飞旋，
  甩动类：左顶甩，左底甩，右顶甩，右反甩，右正甩，右底甩，顶左甩，顶右甩，左正甩，左反甩，
  漂移类：右上飘，右下飘，左上飘，左下飘，
  斜移类：右上移，左上移，右下移，左下移，
  平移类：上平移，下平移，左平移，右平移，左摇晃，右摇晃，
  综合类：隐正显，微闪烁，隐上移，隐下移，滑上升，滑掉落，左反弹，右反弹
==========================
```
##  💁‍♀️ 启用系统字体
```
==========================
--参数：默认，加粗，等宽，有衬，无衬
==========================
调用示例：
==========================
启用系统字体(edit,'无衬')
==========================
```
##  💁‍♀️ 启用路径字体
```
==========================
--1.请在main目录创建fonts文件夹
--2.放置下载好的ttf字体文件
==========================
--调用示例：fonts目录下有文件 zhengkai.ttf
==========================
--启用路径字体(edit,'zhengkai')
==========================
==========================
==========================
```
##  💁‍♀️ 视图效果功能函数
```
==========================
双色渐变(0xff645455,0xff5427863,控件id)
--三色渐变(颜色1,颜色2,控件id)
--五色渐变(颜色1,颜色2,颜色3,颜色4,颜色5,控件id)
--七色渐变(颜色1,颜色2,颜色3,颜色4,颜色5,颜色6,颜色7,控件id)
--十色渐变(颜色1,颜色2,颜色3,颜色4,颜色5,颜色6,颜色7,颜色8,颜色9,颜色10,控件id)
==========================

==========================
上下渐变效果说明：
模式可选：'1'，'2'，允许留空
==========================
上下渐变(渐变模式,颜色1,颜色2,颜色3,颜色4,颜色5)
==========================

==========================
更多颜色支持请使用下面的函数:
修改效果方向：TR_BL TL_BR
追加效果颜色：在颜色2后面追加颜色3,颜色4,颜色5,颜色6,颜色7......请以半角逗号结束
==========================
function 渐变(颜色1,颜色2,控件id)
  drawable = GradientDrawable(GradientDrawable.Orientation.TR_BL,{颜色1,颜色2,});
  控件id.setBackgroundDrawable(drawable)
end
==========================

==========================
带参平移动画(id,方向,模式,幅度,速度)
==========================
1.控件id：布局中的空间id
2.方向：向左|向右|向上|向下
3.模式：循环移动|单次移动|跨屏循环
4.幅度：最小|小幅|中幅|大幅|巨幅|全屏
5.速度：从\'1\'到\'15\'档
==========================

==========================
调用函数
==========================
写法示例:id不用加引号，其它的参数需带引号
带参平移(控件id,'向右','跨屏循环','大幅','13')
==========================

==========================
设置控件圆角
==========================
设置控件圆角(控件ID,圆角)
圆角参数：允许任意正数数值，单位：dp，例如：'5dp'
==========================
```
##  🐥 中文小鸡 帮助文档结束

###  💁‍♀️ FA2手册自带示例框架 分类下的代码作者：
```    
             寒歌，难忘的旋律，dingyi等
                  (排名不分先后)
``` 
###  💁‍♀️ 小鸡模块作者：
#### &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;📯 特别说明：不含官方示例和已标注作者之部分
```
                    G.flower
```
###  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;意见反馈请通过以下方式联系修复
 
```
                微信: KDDS888888
                Q Q: 547430970
```
## 
##  💁‍♀️ 相关交流群推荐
```
 ⭐高级⭐ FA2公测群(FA2官方)：107828217
 ⭐高级⭐ MyLuaApp群(dingyi)：1020019846
 ⭐高级⭐ Luа加固(难忘的旋律) 976449507
 ⭐推荐⭐ 代码手册(帕帝)：778459005
 ⭐推荐⭐ JsHD官方群(壹影)：971820505
 ⭐推荐⭐ 站长交流群(2千高活跃)：741864139
 ⭐初级⭐ ADLua群(小鸡函数)：20078299
```
##   
##   

