--界面管理调用函数
--by：G.flower
require "import"
import "androidx.appcompat.app.AppCompatDelegate$NightMode"
import "net.fusionapp.core.ui.UiManager"

function 界面显示模式(模式,状态栏颜色)
  if 模式==1 then
    if Build.VERSION.SDK_INT >= 21 then
      return activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS).setStatusBarColor(0x55808080)
    end
    if Build.VERSION.SDK_INT >= 19 then
      return activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS)
    end
   elseif 模式==2 then
    activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS)
    activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN)
   elseif 模式==3 then
    activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN)
   elseif 模式==4 then
    return activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS).setStatusBarColor(0x00000000)
   elseif 模式==5 then
    return activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS).setStatusBarColor(0xffffffff)
   elseif 模式==6 then
    return activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS).setStatusBarColor(状态栏背景色)
   else
  end
end

--屏幕方向控制
function 屏幕方向(方向)
  import "android.content.pm.ActivityInfo"
  local 方向控制 = activity.setRequestedOrientation
  local 自动转屏 = ActivityInfo.SCREEN_ORIENTATION_SENSOR
  if 方向 == "正向" then
    print(1)
    return 方向控制(1)
   elseif 方向 == "左转" then
   print(2)
    return 方向控制(8)
   elseif 方向 == "右转" then
   print(3)
    return 方向控制(0)
   elseif 方向 == "倒置" then
   print(4)
    return 方向控制(9)
   elseif 方向 == "自动" then    
   print(5)
    return 方向控制(4)
   else
   print(6)
    return 方向控制(1)
  end
end

--界面管理器
function 界面管理器()
  return activity.uiManager
end
function getUiManager()
  return activity.uiManager
end

--界面滑动视图
function 界面滑动视图()
  return 界面管理器().viewPager
end
function getViewPager()
  return 界面管理器().viewPager
end

function 协调器布局()
  return 界面管理器().coordinatorLayout
end
function COLayout()
  return 界面管理器().coordinatorLayout
end

--滑动视图适配器
function 滑动视图适配器()
  return 界面管理器().pagerAdapter
end
function PagAdapter()
  return 界面管理器().pagerAdapter
end

--获取主题配置
function 获取主题配置()
  return 界面管理器().themeConfig
end
function getThemeConf()
  return 界面管理器().themeConfig
end
--获取视图配置
function 获取视图配置()
  return 界面管理器().getViewConfig()
end
function getViewConf()
  return 界面管理器().getViewConfig()
end
--获取主题颜色
function 获取主题配色()
  return activity.getUiManager().getColors()
end
function getThemeColor()
  return activity.getUiManager().getColors()
end
function 主题背景配色()
  local BKColor = getThemeColor().getWindowBackground()
  return BKColor
end
function SetBkColor()
  local BKColor = getThemeColor().getWindowBackground()
  return BKColor
end
--主题基础配色
function 主题基础配色()
  local PRColor = getThemeColor().getColorPrimary()
  return PRColor
end
function SetPrColor()
  local PRColor = getThemeColor().getColorPrimary()
  return PRColor
end
--主题强调配色
function 主题强调配色()
  local ATColor = getThemeColor().getColorAccent()
  return ATColor
end
function SetTaColor()
  local ATColor = getThemeColor().getColorAccent()
  return ATColor
end
--主题文本配色
function 主题主文本配色()
  local PTColor = getThemeColor().getTextColorPrimary()
  return PTColor
end
function SetTpColor()
  local PTColor = getThemeColor().getTextColorPrimary()
  return PTColor
end
--主题副文本配色
function 主题副文本配色()
  local STColor = getThemeColor().getTextColorSecondary()
  return STColor
end
function SetTsColor()
  local STColor = getThemeColor().getTextColorSecondary()
  return STColor
end
--设置应用主题
function 设置应用主题(主题名称,图标设置)
  local config=activity.getViewConfig().getToolbar().getMenus()
  if 图标设置 then
    config[1].setIcon("wb_sunny")
    config[1].setIcon("brightness_4")
  end
  activity.getLoader().updatePageConfig()
  FusionUtil.setNightMode(!isNightMode())
  FusionUtil.changeTheme(activity.getLoader().getProjectDir().getAbsolutePath(), 主题名称..".json")
  activity.finish()
  activity.startFusionActivity(activity.getLoader().getPageName())
  activity.overridePendingTransition(android.R.anim.fade_in,android.R.anim.fade_out)
end
function SetTheme(name,a)
  local config=activity.getViewConfig().getToolbar().getMenus()
  if a then
    config[1].setIcon("wb_sunny")
    config[1].setIcon("brightness_4")
  end
  activity.getLoader().updatePageConfig()
  FusionUtil.setNightMode(!isNightMode())
  FusionUtil.changeTheme(activity.getLoader().getProjectDir().getAbsolutePath(), name..".json")
  activity.finish()
  activity.startFusionActivity(activity.getLoader().getPageName())
  activity.overridePendingTransition(android.R.anim.fade_in,android.R.anim.fade_out)
end
--夜间主题模式
function 夜间主题模式()
  return activity.getSharedData("nightmode")==2
end
function NightMode()
  return activity.getSharedData("nightmode")==2
end


